#include <asm/unistd.h>

.global _start
_start:
	popl	%ecx			// argc
	movl	%esp,%eax		// (char**)argv
	leal	4(%esp,%ecx,4),%ebx	// (char**)envp
	pushl	%ebx
	pushl	%eax
	pushl	%ecx
	call	main
	// noreturn

.global execve
execve:
	popl	%eax		// discard old return address
	push	$exit
	push	$__NR_execve
	jmp	.Lkern3

.global kill
kill:
	push	$__NR_kill
	jmp	.Lkern3

.global sethostname
sethostname:
	push	$__NR_sethostname
	jmp	.Lkern3

.global setdomainname
setdomainname:
	push	$__NR_setdomainname
	jmp	.Lkern3

.global waitpid
waitpid:
	push	$__NR_waitpid
	jmp	.Lkern3

.global read
read:
	push	$__NR_read
	jmp	.Lkern3

.global write
write:
	push	$__NR_write
	jmp	.Lkern3

.global open
open:
	push	$__NR_open
	jmp	.Lkern3

.global close
close:
	push	$__NR_close
	jmp	.Lkern3

.global signal
signal:
	push	$__NR_signal
	// fall through

.Lkern3:
	popl	%eax
	pushl	%ebx
	movl	16(%esp),%edx
	movl	12(%esp),%ecx
	movl	8(%esp),%ebx
	int	$0x80
	popl	%ebx
	ret

.global pause
pause:
	push	$__NR_pause
	jmp	.Lkern0

.global fork
fork:
	push	$__NR_fork
	// fall through

.Lkern0:
	popl	%eax
	int	$0x80
	ret

.global	exit
exit:
	popl	%ebx		// discard
	popl	%ebx		// exit arg
	xorl	%eax,%eax
	incl	%eax
	int	$0x80
	// if we return from exit we might aswell do an uncontrolled crash

.global chop
chop:
	movl	4(%esp),%eax
.Lchop0:
	movb	(%eax),%cl
	xorb	$'\n',%cl
	je	.Lchop1
	incl	%eax
	or	%cl,%cl
	jnz	.Lchop0
	ret
.Lchop1:
	movb	%cl,(%eax)
	ret

.global str_confpath
str_confpath:
	.string	"/etc/init/"
	.byte	0

.global str_autoopt
str_autoopt:
	.string	"auto"
	.byte	0

.global str_spawn
str_spawn:
	.string	"spawn"
	.byte	0

.global str_term
str_term:
	.string	"term"
	.byte	0

.global str_hostname
str_hostname:
	.string "hostname"
	.byte	0

.global str_domainname
str_domainname:
	.string "domainname"
	.byte	0

.global	bannerfmt
bannerfmt:
	.string	"INIT: twsinit version 0.1 booting (%s)\n"
	.byte	0

.global devnull
devnull:
	.string	"/dev/null"
	.byte	0

#ifdef VERBOSE

.global respawnfmt
respawnfmt:
	.string	"INIT: respawn `%s' [job %i: `%s'] = pid %i\n"
	.byte	0

.global termfmt
termfmt:
	.string	"INIT: SIGTERM received -- running `%s'\n"
	.byte	0

#endif /* VERBOSE */

