#include <asm/unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
//#include <asm/signal.h>
#include <sys/time.h>
#include <asm/fcntl.h>

pid_t getsid(pid_t);
pid_t getpid(void);
pid_t getppid(void);
int execve(const char *, char *const [], char *const []) __attribute__(( __noreturn__ ));
int kill(pid_t, int);
ssize_t write(int, const void *, size_t);
void exit(int) __attribute__(( __noreturn__ ));
void printf(const char *, ...);

#define MSGLEN		512
#define MAXCOMLEN	512
#define MAXOPTLEN	32
#define MAXARG		8
#define MAXENV		8
#define MAXSPAWNS	8

extern char fmt1;
extern char fmt2;
extern char fmt3;

int main(int argc, char **argv, char **envp) __attribute__(( __noreturn__ ));
int main(int argc, char **argv, char **envp)
{
	char	*p;
	pid_t	pid,ppid;
	int	i,ret,sig;

	sig = 0;
	p = argv[1];
	while(p && *p)
	{
		if (*p == '-')
			;
		else
		if (*p >= '0' || *p <= '9')
		{
			sig = (sig * 10) + (*p - '0');
		}
		else
			exit(1);
		p++;
	}
	printf(&fmt1,sig);
	pid = getpid();
	ppid = getppid();
	for(i=2;i<65536;i++)
	{
		ret = getsid(i);
		if ((ret > 1) && (i != pid) && (i != ppid))
		{
			printf(&fmt2,i);
			kill(i,sig);
		}
	}
	write(1,&fmt3,2);
	exit(0);
}

